<template>
  <section class="p-4  my-4">
    <h1>Builder</h1>
    <div v-if="errorMessage" class="alert alert-danger">
      {{ errorMessage }}
    </div>
    <div class="my-5">
      <div class="mb-5">
        <div class="row">
          <div class="form-group col-4" id="title">
            <label class="col-form-label">Titolo</label>
            <div>
              <input v-model="service['title']" spellcheck="true" class="form-control" type="text"
                     name="title" required>
            </div>
          </div>
          <div class="form-group col-4" id="name">
            <label class="col-form-label">Nome</label>
            <div>
              <input v-model="service['name']" spellcheck="true" class="form-control" type="text"
                     name="name" required>
            </div>
          </div>
          <div class="form-group col-4" id="path">
            <label class="col-form-label">Path</label>
            <div>
              <input v-model="service['path']" spellcheck="true" class="form-control" type="text"
                     name="path" required>
            </div>
          </div>
          <div class="form-group col-12" id="description">
            <label class="col-form-label">Descrizione</label>
            <div>
                    <textarea rows="4" v-model="service['description']" spellcheck="true" class="form-control"
                              name="description" required></textarea>
            </div>
          </div>
        </div>
        <div class="row pt-3">
          <div class="col-4">
            <div class="select-wrapper">
              <label class="col-form-label font-weight-semibold">Display</label>
              <select name="display" v-model="service['display']" @change="changeDisplay" required>
                <option value="form">Form</option>
                <option value="wizard">Wizard</option>
              </select>
            </div>
          </div>
          <div class="col-4">
            <div class="select-wrapper">
              <label class="col-form-label font-weight-semibold">Tag</label>
              <select name="tag" v-model="service['tags'][0]" required>
                <option value="custom">Personalizzato</option>
                <option value="component">Componente</option>
              </select>
            </div>
          </div>
          <div class="col-4">
            <div>
              <div class="form-check">
                <input id="deprecated" type="checkbox" v-model="service['deprecated']">
                <label for="deprecated">Deprecato</label>
              </div>
            </div>
          </div>
        </div>
      </div>
      <div class="float-end">
        <button v-if="service['_id']" type="button" class="btn btn-outline-primary mr-3" @click="editForm">Modifica
        </button>
        <button v-else type="button" class="btn btn-outline-primary mr-3" @click="editForm">Crea</button>
      </div>
      <div class="clearfix"></div>
      <div class="my-4" id="builder"></div>
      <div class="clearfix"></div>
      <div class="float-end">
        <button v-if="service['_id']" type="button" class="btn btn-outline-primary mr-3" @click="editForm">Modifica
        </button>
        <button v-else type="button" class="btn btn-outline-primary mr-3" @click="editForm">Crea</button>
      </div>
      <div class="clearfix"></div>
    </div>
  </section>
  <section class="p-4  my-4" v-if="loading">
    <div class="justify-content-center d-flex mb-3">
      <div class="progress-spinner progress-spinner-active">
        <span class="sr-only">Caricamento...</span>
      </div>
    </div>
  </section>
</template>

<script>

import axios from "axios";
import router from "@/router/router";
import {useRoute} from "vue-router";
import {computed, watch} from "vue";

const builder = {
  builder: {
    basic: false,
    advanced: false,
    data: false,
    layout: false,
    premium: false,
    resource: false,
    customBasic: {
      title: 'Componenti',
      default: true,
      weight: 0,
      components: {
        textfield: true,
        textarea: true,
        checkbox: true,
        number: true,
        select: true,
        radio: true,
        selectboxes: true,
        email: true,
        phoneNumber: false,
        url: true,
        datetime: false,
        day: true,
        time: true,
        currency: true,
        hidden: true,
        form: true,
        calendar: true,
        dynamic_calendar: true,
        sdcfile: {
          title: 'File Sdc',
          key: 'sdcfile',
          icon: 'file',
          schema: {
            label: 'File',
            type: 'sdcfile',
            key: 'sdcfile',
            input: true,
            storage: "url",
            fileMinSize: "1KB",
            fileMaxSize: "10MB",
            url: window.location.protocol + "//" + window.location.host + "/" + window.location.pathname.split("/")[1] + "/it/upload",
          }
        },
        financial_report: true,
        address: true,
        survey: true
      }
    },
    customLayout: {
      title: 'Layout',
      default: false,
      weight: 0,
      components: {
        htmlelement: true,
        columns: true,
        pagebreak: true,
        table: true,
        datagrid: {
          title: 'Datagrid',
          key: 'Datagrid',
          icon: 'th',
          schema: {
            label: 'Datagrid',
            type: 'datagrid',
            key: 'datagrid',
            input: true,
            customDefaultValue: "value = [{}]",
          }
        },
        well: true,
        panel: true,
        editgrid: true,
        fieldset: true
      }
    },
  }
}

export default {
  name: 'BuilderPage',
  setup() {
    const route = useRoute()
    const searchQuery = computed(() => route.query.id)

    watch(searchQuery, newSearchQuery => console.log(newSearchQuery))
    const api_url = window.location.protocol + "//" + window.location.hostname + "/api"
    console.log("Setting api_url to: " + api_url)
    return {
      searchQuery
    }
  },
  data() {
    return {
      service: {
        components: [],
        title: '',
        name: '',
        description: '',
        path: '',
        display: 'form',
        tags: ['custom'],
        deprecated: false
      },
      errorMessage: '',
      loading: false
    };
  },
  mounted() {
    this.service = {
      components: [],
      title: '',
      name: '',
      description: '',
      path: '',
      display: 'form',
      tags: ['custom'],
      deprecated: false
    };
    console.log("set form.io url: " + window.location.protocol + "//" + window.location.hostname + "/api");
    // eslint-disable-next-line no-undef
    Formio.setBaseUrl(window.location.protocol + "//" + window.location.hostname + "/api");
    // eslint-disable-next-line no-undef
    Formio.setProjectUrl(window.location.protocol + "//" + window.location.hostname + "/api");
    if (this.searchQuery) {
      this.getService();
    } else {
      // eslint-disable-next-line no-undef
      Formio.builder(document.getElementById('builder'), {}, builder)
    }
  },
  methods: {
    getService() {
      this.loading = true;
      axios.get(`/api/form/${this.$route.query.id}`).then((result) => {
        this.service = result.data;
        // eslint-disable-next-line no-undef
        Formio.builder(document.getElementById('builder'), result.data, builder);
        this.loading = false;
      }, () => {
        this.errorMessage = 'Non è stato possibile recuperare il servizio';
      });
    },
    editForm() {
      if (this.service._id) {
        axios.put(`/api/${this.service.path}`, this.service).then((result) => {
          router.push(`/services/${result.data._id}`);
        }, () => {
          this.errorMessage = 'Non è stato possibile aggiornare il servizio';
        });
      } else {
        axios.post(`/api/form`, this.service).then((result) => {
          router.push(`/services/${result.data._id}`);
        }, () => {
          this.errorMessage = 'Non è stato possibile creare il servizio';
        });
      }
    },
    changeDisplay() {
      if (this.service.display !== 'form') {
        this.service.components = [{
          type: 'panel',
          input: false,
          title: 'Page 1',
          theme: 'default',
          components: this.service.components,
        }];
      } else {
        let newComponents = [];
        this.service.components.forEach((component) => {
          newComponents = [...[...newComponents, ...component.components]];
        });
        this.service.components = newComponents;
      }


      // eslint-disable-next-line no-undef
      Formio.builder(document.getElementById('builder'), this.service, builder);

    }
  }
};
</script>
<style scoped>

</style>
